/* Copyright 2015, Michele Santullo
 * This file is part of DoorKeeper.
 *
 * DoorKeeper is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * DoorKeeper is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with DoorKeeper.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef idB5DCDE44F8E148AA8DD1CBD12649EFCD
#define idB5DCDE44F8E148AA8DD1CBD12649EFCD

#include <gtest/gtest.h>
#include "doorkeeper/doorkeeper.hpp"

class asciimapsource : public ::testing::Test {
protected:
	typedef dk::Tyler<2>::coords coords2;
	typedef std::unique_ptr<dkh::AsciiMapSource> AsciiMapSourceUPtr;

	asciimapsource ( void );
	virtual ~asciimapsource ( void ) noexcept = default;
	virtual void SetUp ( void );

	static const char map_data[];
	static const dk::CoordinateScalarType tile_size;
	static const dk::CoordinateScalarType map_width;
	static const dk::CoordinateScalarType map_height;

	dk::Tyler<2> tiler;
	dk::Layer<dkh::AsciiMapSource::MapTileType, 2>* layer;
	AsciiMapSourceUPtr loader;
};

#endif
